package uulm.teamname.marvelous.server.game.pipelining;

import org.tinylog.Logger;
import uulm.teamname.marvelous.gamelibrary.events.Event;
import uulm.teamname.marvelous.gamelibrary.gamelogic.GameInstance;
import uulm.teamname.marvelous.gamelibrary.messages.server.EventMessage;
import uulm.teamname.marvelous.gamelibrary.requests.RequestType;
import uulm.teamname.marvelous.server.game.GameSession;

import java.util.List;
import java.util.concurrent.atomic.AtomicBoolean;

/**
 * The {@link RequestGameStateSegment} handles requests of {@link RequestType} Req.
 */
public class RequestGameStateSegment implements Segment {

    private final GameSession parent;


    public RequestGameStateSegment(GameSession parent) {
        this.parent = parent;
    }

    @Override
    public void processRequests(Packet packet, List<Event> carrier, AtomicBoolean abort) {
        Logger.trace("RequestGameStateSegment received {} requests", packet.size());

        if(packet.containsRequestOfType(RequestType.Req)) {
            Logger.trace("Req event found. Returning GameState, and clearing entire RequestList");
            EventMessage message = new EventMessage();
            message.messages = new Event[] {parent.getInstance().getGameStateEvent()};
            packet.getOrigin().sendMessage(message);
            carrier.clear();
            packet.clear();
        }
    }
}
